// BabelOn.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "BabelOn.h"
#include "BabelOnDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CBabelOnApp

BEGIN_MESSAGE_MAP(CBabelOnApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CBabelOnApp construction

CBabelOnApp::CBabelOnApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CBabelOnApp object

CBabelOnApp theApp;


// CBabelOnApp initialization

BOOL CBabelOnApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	
	//her we create a mutex to ensure that only one instance will be open
	CreateMutex(NULL,TRUE,_T("BabelOnMutex")); // mutex will be automatically deleted when process ends. 
	BOOL bAlreadyRunning = (GetLastError() == ERROR_ALREADY_EXISTS); 
	if(bAlreadyRunning) 
		return FALSE; 

	InitCommonControls();
	
	CWinApp::InitInstance();
	SetRegistryKey(_T("Ben Watson"));
	CBabelOnDlg dlg;
	//load stuff from registry HKEY_CURRENT_USER\Software\Ben Watson\BabelOn
	dlg.sel_language=GetProfileInt(_T(""),_T("LanguageMode"),0);
	dlg.default_language=GetProfileInt(_T(""),_T("DefaultLanguageMode"),0);
	dlg.proxy=GetProfileString(_T(""),_T("Proxy"),NULL);
	dlg.proxy_port=GetProfileInt(_T(""),_T("ProxyPort"),0);
	dlg.timeout=GetProfileInt(_T(""),_T("Timeout"),10);
	dlg.load_default=GetProfileInt(_T(""),_T("AlwaysLoadDefault"),FALSE);
	dlg.start_minimized=GetProfileInt(_T(""),_T("StartMinimized"),FALSE);
	dlg.x=GetProfileInt(_T(""),_T("x"),::GetSystemMetrics(SM_CXSCREEN)/2);//default screen position is roughly in the middle
	dlg.y=GetProfileInt(_T(""),_T("y"),::GetSystemMetrics(SM_CYSCREEN)/2);
	dlg.alphaBlend=GetProfileInt(_T(""),_T("AlphaBlend"),255);
	m_pMainWnd = &dlg;

	INT_PTR nResponse = dlg.DoModal();
	//save to the registry
	WriteProfileInt(_T(""),_T("LanguageMode"),dlg.sel_language);
	WriteProfileInt(_T(""),_T("DefaultLanguageMode"),dlg.default_language);
	WriteProfileString(_T(""),_T("Proxy"),dlg.proxy);
	WriteProfileInt(_T(""),_T("ProxyPort"),dlg.proxy_port);
	WriteProfileInt(_T(""),_T("Timeout"),dlg.timeout);
	WriteProfileInt(_T(""),_T("AlwaysLoadDefault"),dlg.load_default);
	WriteProfileInt(_T(""),_T("StartMinimized"),dlg.start_minimized);
	WriteProfileInt(_T(""),_T("x"),dlg.x);
	WriteProfileInt(_T(""),_T("y"),dlg.y);
	WriteProfileInt(_T(""),_T("AlphaBlend"),dlg.alphaBlend);
	

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

void GetOS(CString &sSystem)
{
    CString sKey; 
    sSystem="<Unknown>"; 
    sKey.Format("SOFTWARE\\Microsoft\\%s\\CurrentVersion",
               (getenv("OS")? "Windows NT":"Windows"));
    HKEY hKey=0; 
    RegOpenKeyEx(HKEY_LOCAL_MACHINE,sKey,0,KEY_ALL_ACCESS,
                 &hKey);
    if (hKey) {
        CString sTitle("ProductName"); 
        DWORD dwType=REG_SZ,nD=250; 
        char sV[250]; BYTE *pD=(BYTE*)sV;
        RegQueryValueEx(hKey,sTitle,0,&dwType,pD,&nD);
        if (strlen(sV))
            sSystem=sV;
        else sSystem="Windows NT";
        RegCloseKey(hKey);
        }
 }
