// BabelOnDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BabelOn.h"
#include "BabelOnDlg.h"
#include "settingsdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//these are the possible translation modes provided by the BabelFish web service
const int num_Modes=11;
CString languages[num_Modes][2]=
	{
	{"English to Spanish","en_es"},
	{"English to French","en_fr"},
	{"English to Italian","en_it"},
	{"English to German","en_de"},
	{"English to Portugese","en_pt"},
	{"Spanish to English","es_en"},
	{"French to English","fr_en"},
	{"Italian to English","it_en"},
	{"German to English","de_en"},
	{"Portugese to English","pt_en"},
	{"Russian to English","ru_en"},
	};


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


CBabelOnDlg::CBabelOnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBabelOnDlg::IDD, pParent)

	, alphaSupported(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBabelOnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_MODE, m_mode);
	DDX_Control(pDX, IDC_TARGET, m_target);
	DDX_Control(pDX, IDC_SOURCE, m_source);
	DDX_Control(pDX, IDC_STATUS, statusCtrl);
}

BEGIN_MESSAGE_MAP(CBabelOnDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP

	ON_CBN_SELCHANGE(IDC_MODE, OnCbnSelchangeMode)
	ON_BN_CLICKED(IDC_TRANSLATE, OnBnClickedTranslate)
	ON_BN_CLICKED(IDC_SETTINGS, OnBnClickedSettings)
	ON_BN_CLICKED(IDC_PASTE, OnBnClickedPaste)
	ON_BN_CLICKED(IDC_COPY, OnBnClickedCopy)
	ON_MESSAGE(WM_USER_TRAY_NOTIFICATION,OnTrayNotification)
	ON_WM_CLOSE()
	ON_COMMAND(IDC_SHOW, OnShow)
	ON_COMMAND(IDC_EXIT, OnExit)
	ON_COMMAND(IDM_ABOUTBOX, OnAboutbox)
	ON_WM_MOVE()
END_MESSAGE_MAP()


// CBabelOnDlg message handlers

BOOL CBabelOnDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." and "Exit" menu items to system menu.

	// Command IDs must be in system range
	// the ANDing is because of a bug in Windows 95

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	ASSERT((IDM_EXIT & 0xFFF0) == IDM_EXIT);
	ASSERT(IDM_EXIT < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_STRING,IDM_EXIT,"E&xit Program");
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, "A&bout BabelOn");
	}
	

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//show tray icon
	m_trayIcon.Create(this, WM_USER_TRAY_NOTIFICATION, "BabelOn translation service", 
	                  m_hIcon, IDM_TRAYICONMENU);

	//initialize controls
	for (int i=0;i<num_Modes;i++)
		m_mode.InsertString(i,languages[i][0]);
	if (load_default)
		m_mode.SetCurSel(default_language);
	else
		m_mode.SetCurSel(sel_language);
	
	
	if (start_minimized)
		PostMessage(WM_CLOSE);
	
	//set window position based on last known position,
	//checking to make sure if it's on the screen
	//and moving it accordingly
	//this probably doesn't work if you move it off the left or top sides of the screen,
	//which is hard to do anyway

	int cx=::GetSystemMetrics(SM_CXFULLSCREEN);
	int cy=::GetSystemMetrics(SM_CYFULLSCREEN);
	
	CRect rect;
	GetWindowRect(&rect);
	if (x+rect.Width()>cx)
		rect.MoveToX(cx-rect.Width());
	else
		rect.MoveToX(x);
	if (y+rect.Height()>cy)
		rect.MoveToY(cy-rect.Height());
	else
		rect.MoveToY(y);
	MoveWindow(&rect);
	
	m_source.SetLimitText(300);//BabelFish has an input limit of 300 characters

	//these next two lines allow us to have a window that doesn't show a taskbar button and can be translucent under Windows 2000 and higher
	/*OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx (&osvi);
	if (osvi.dwMajorVersion>=5)
		alphaSupported=TRUE;

    if (alphaSupported==TRUE) {
		
		::SetWindowLong(m_hWnd,GWL_EXSTYLE,WS_EX_LAYERED|WS_EX_TOOLWINDOW|WS_EX_TOPMOST );	//make this a layered window
		SetLayeredWindowAttributes(NULL,alphaBlend,LWA_ALPHA);
	} */
	GetDlgItem(IDC_SOURCE)->SetFocus();

	return FALSE;  // return TRUE  unless you set the focus to a control
}

void CBabelOnDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	//trap our own system menu messages
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	} else if ((nID & 0xFFF0)==SC_CLOSE){
		OnClose();
	} else if ((nID & 0xFFF0)==IDM_EXIT) {
		::PostQuitMessage(0);
	}

	 else {
	
		CDialog::OnSysCommand(nID, lParam);
}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBabelOnDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBabelOnDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


//user changed the translation mode
void CBabelOnDlg::OnCbnSelchangeMode()
{
	sel_language=m_mode.GetCurSel();
	m_source.SetFocus();
}

void CBabelOnDlg::OnBnClickedTranslate()
{
	
	HCURSOR oldCursor=SetCursor(LoadCursor(NULL,IDC_WAIT));
		
	CString temp;
	m_source.GetWindowText(temp);

	BSTR source=temp.AllocSysString();		//must convert to a system string
	BSTR dest=SysAllocStringLen(NULL,4096);//empty system string for output

	CString temp2=languages[sel_language][1];
	BSTR lang=temp2.AllocSysString();		//translation mode
	
	if (SUCCEEDED(CoInitialize(NULL))) {	//only access service if we can init ATL layer
		CBabelFishService fish;
		if (proxy.GetLength() > 0) {		
			HRESULT hr=fish.SetProxy(proxy,proxy_port);
			if (FAILED(hr)) {
				statusCtrl.SetWindowText("Unable to set proxy server.");
				m_source.SetFocus();
				return;
			}
		}
		
		fish.SetTimeout(timeout*1000);
		int numTries=0;
		HRESULT hr;
		do {//try a couple times in case it fails on the first one (don't know why, but sometimes it does)
			hr=fish.BabelFish(lang, source,&dest);
		} while (numTries++ < MAXTRIES && FAILED(hr));	

		if (FAILED(hr)) {
			statusCtrl.SetWindowText("Unable to access service. Check proxy setting and internet connection.");
			m_source.SetFocus();
		}
		else {
			m_target.SetWindowText(CString(dest));
			statusCtrl.SetWindowText("Translation successful");
		}
		//make sure we deallocate memory
		SysFreeString(source);
		SysFreeString(dest);
		
		
	}
	CoUninitialize();
	SetCursor(oldCursor);
	m_source.SetFocus();
}



void CBabelOnDlg::OnBnClickedSettings()
{
	CSettingsDlg dlg;
	//init dialog box
	dlg.m_alwaysUseDefault=load_default;
	dlg.m_proxy=proxy;
	dlg.m_proxyPort=proxy_port;
	dlg.m_timeout=timeout;
	dlg.default_language=default_language;
	dlg.m_startMinimized=start_minimized;
	dlg.m_alphaBlend=alphaBlend;
	dlg.alphaSupported=alphaSupported;
	if (dlg.DoModal()==IDOK) {
		//save dialog box values
		timeout=dlg.m_timeout;
		proxy_port=dlg.m_proxyPort;
		proxy=dlg.m_proxy;
		
		load_default=dlg.m_alwaysUseDefault;
		default_language=dlg.default_language;
		start_minimized=dlg.m_startMinimized;
		alphaBlend=dlg.m_alphaBlend;
		//set alphablend
		/*if (alphaSupported)
			SetLayeredWindowAttributes(NULL,alphaBlend,LWA_ALPHA);*/
	}
	m_source.SetFocus();
	
	
}

void CBabelOnDlg::OnBnClickedPaste()
{
	m_source.Paste();
	m_source.SetFocus();
}

void CBabelOnDlg::OnBnClickedCopy()
{
	int start, end;
	m_target.GetSel(start,end);//get current selection
	if (end==0)					//if nothing selected, select everything
		m_target.SetSel(0,-1,TRUE);
	m_target.Copy();
	m_target.SetSel(start,end,TRUE);
	m_source.SetFocus();
}



void CBabelOnDlg::OnClose()
{
		ShowWindow(SW_HIDE);
}

LONG CBabelOnDlg::OnTrayNotification(WPARAM wparam, LPARAM lparam)
{   // The tray icon sent us a message.  Let's see what it is
    switch ( lparam )
    {
        case WM_CONTEXTMENU:
            TRACE( "WM_CONTEXTMENU\n" );
        case WM_RBUTTONDOWN:
            {// The user clicked the right mouse button.
             // Let's give them a menu so they can start/stop   
             // the animation.   
                CMenu oMenu;
                if (oMenu.LoadMenu(IDM_TRAYICONMENU))        
                {
                    CMenu* pPopup = oMenu.GetSubMenu(0);
                    ASSERT(pPopup != NULL);
                    CPoint oPoint;
					if (IsWindowVisible())//modify menu based on whether it's showing
						oMenu.ModifyMenu(IDC_SHOW,MF_STRING,IDC_SHOW,"&Hide");
					else
						oMenu.ModifyMenu(IDC_SHOW,MF_STRING,IDC_SHOW,"&Show");
                    // Figure out where the mouse is so we
                    // can display the menu near it.
					GetCursorPos( &oPoint );
                    SetForegroundWindow();
                    pPopup->TrackPopupMenu(
                        TPM_LEFTALIGN | TPM_RIGHTBUTTON,
                        oPoint.x, oPoint.y, this); 
                }
            }
            break;
		case WM_LBUTTONDBLCLK:
		case WM_LBUTTONDOWN:
			OnShow();
			break;
    }
    return 0;
}
void CBabelOnDlg::OnShow()
{
	//toggle window visibility
	if (!IsWindowVisible()) {
		ShowWindow(SW_SHOW);
	}
	else
		ShowWindow(SW_HIDE);
}

void CBabelOnDlg::OnExit()
{
	::PostQuitMessage(0);//only way to exit
}


void CBabelOnDlg::OnCancel()
{
	//override escape key
	OnClose();

}


//int CBabelOnDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
//{
//	if (CDialog::OnCreate(lpCreateStruct) == -1)
//		return -1;
//
//	return 0;
//}

void CBabelOnDlg::OnAboutbox()
{
	CAboutDlg dlg;
	dlg.DoModal();
	m_source.SetFocus();
}

void CBabelOnDlg::OnMove(int newX, int newY)
{
	CDialog::OnMove(x, y);
	if (IsWindowVisible()) {//this test ensure that these coordinates will not be overwritten with the position of
							//a newly created window, which is invisible
		x=newX;
		y=newY;
	}
}
