// BabelOnDlg.h : header file
//
#include "afxwin.h"
#include "systemtray.h"

#include "babelfishservice.h" 
using namespace BabelFishService;

#define MAXTRIES 3
//we need a custom message for receiving notifications from the tray
#define WM_USER_TRAY_NOTIFICATION (WM_USER+0x101)

#define IDM_EXIT 0x0020

#pragma once

// CBabelOnDlg dialog
class CBabelOnDlg : public CDialog
{
// Construction
public:
	CBabelOnDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_BABELON_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	
public:
	//all of this is public so that we can initialize them in the application's InitInstance()
	int sel_language;//current language selection, to save in registry
	int default_language;//the one set as the default in the settings dlg
	BOOL load_default;
	
	BOOL start_minimized;
	CString proxy;
	int proxy_port;
	int timeout;//time out for accessing web service
	int x,y;//window position
	int alphaBlend;
	BOOL alphaSupported;


// Implementation
protected:
	HICON m_hIcon;
	CSystemTray m_trayIcon;;
	
	CComboBox m_mode;
	CEdit m_target;
	CEdit m_source;
	CStatic statusCtrl;

	
	// Generated message map functions

	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCbnSelchangeMode();
	afx_msg void OnBnClickedTranslate();
	afx_msg LONG OnTrayNotification( WPARAM wparam, LPARAM lparam );
	afx_msg void OnBnClickedPaste();
	afx_msg void OnBnClickedCopy();
	afx_msg void OnBnClickedSettings();
	afx_msg void OnClose();
	afx_msg void OnAboutbox();
	afx_msg void OnMove(int x, int y);
	afx_msg void OnShow();
	afx_msg void OnExit();

	
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	
	DECLARE_MESSAGE_MAP()
	
};
