// SettingsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BabelOn.h"
#include "SettingsDlg.h"


// CSettingsDlg dialog

IMPLEMENT_DYNCREATE(CSettingsDlg, CDialog)

BEGIN_MESSAGE_MAP(CSettingsDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_DEFAULTLANGUAGE, OnCbnSelchangeDefaultlanguage)
//	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
//ON_BN_CLICKED(IDC_DISCOVER, OnBnClickedDiscover)
END_MESSAGE_MAP()

CSettingsDlg::CSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(IDD, pParent)
	, m_proxy(_T(""))
	, m_proxyPort(0)
	, m_timeout(0)
	, m_alwaysUseDefault(FALSE)
	, default_language(0)
	, m_startMinimized(FALSE)
	, m_alphaBlend(0)
{
}

CSettingsDlg::~CSettingsDlg()
{
}

void CSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_PROXY, m_proxy);
	DDX_Text(pDX, IDC_PROXYPORT, m_proxyPort);
	DDX_Text(pDX, IDC_TIMEOUT, m_timeout);
	DDX_Check(pDX, IDC_ALWAYSUSEDEFAULT, m_alwaysUseDefault);
	DDX_Control(pDX, IDC_DEFAULTLANGUAGE, m_langCtrl);
	DDX_Check(pDX, IDC_STARTMINIMIZED, m_startMinimized);
	DDX_Text(pDX, IDC_ALPHABLEND, m_alphaBlend);
	DDX_Control(pDX, IDC_ALPHASPINNER, m_alphaSpinner);
	DDX_Control(pDX, IDC_TIMEOUTSPIN, m_timerSpinner);
	DDV_MinMaxInt(pDX, m_alphaBlend, 100, 255);
	DDV_MinMaxInt(pDX, m_timeout, 1, 30);
}

BOOL CSettingsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	for (int i=0;i<num_Modes;i++)
		m_langCtrl.InsertString(i,languages[i][0]);
	m_langCtrl.SetCurSel(default_language);
	
	m_timerSpinner.SetRange(1,30);
	m_alphaSpinner.SetRange(150,255);
	if (!alphaSupported) {
		m_alphaSpinner.EnableWindow(FALSE);
		GetDlgItem(IDC_ALPHABLEND)->EnableWindow(FALSE);
	}
	GetDlgItem(IDC_PROXY)->SetFocus();
	return FALSE;  // return TRUE  unless you set the focus to a control
}


void CSettingsDlg::OnCbnSelchangeDefaultlanguage()
{
	default_language=m_langCtrl.GetCurSel();
}


